org.apache.solr.core

## Class SolrConfig

- java.lang.Object
- - org.apache.solr.core.Config
  - - org.apache.solr.core.SolrConfig

- All Implemented Interfaces:
    MapSerializable

      public class SolrConfig
      extends Config
      implements MapSerializable

  Provides a static reference to a Config object modeling the main configuration data for a a Solr instance -- typically found in "solrconfig.xml".

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `SolrConfig.HttpCachingConfig`
    `static class` | `SolrConfig.JmxConfiguration`
    `static class` | `SolrConfig.PluginOpts`
    `static class` | `SolrConfig.SolrPluginInfo`
    `static class` | `SolrConfig.UpdateHandlerInfo`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `int` | `booleanQueryMaxClauseCount`
    `static Map<String,SolrConfig.SolrPluginInfo>` | `classVsSolrPluginInfo`
    `protected String` | `dataDir`
    `static String` | `DEFAULT_CONF_FILE`
    `CacheConfig` | `documentCacheConfig`
    `boolean` | `enableLazyFieldLoading`
    `CacheConfig` | `fieldValueCacheConfig`
    `CacheConfig` | `filterCacheConfig`
    `int` | `hashDocSetMaxSize`
    `float` | `hashSetInverseLoadFactor`
    `SolrIndexConfig` | `indexConfig`
    `SolrConfig.JmxConfiguration` | `jmxConfig`
    `Version` | `luceneMatchVersion`
    `int` | `maxWarmingSearchers`
    `static List<SolrConfig.SolrPluginInfo>` | `plugins`
    `CacheConfig` | `queryResultCacheConfig`
    `int` | `queryResultMaxDocsCached`
    `int` | `queryResultWindowSize`
    `int` | `slowQueryThresholdMillis`
    `protected SolrConfig.UpdateHandlerInfo` | `updateHandlerInfo`
    `boolean` | `useColdSearcher`
    `boolean` | `useFilterForSortedQuery`
    `boolean` | `useRangeVersionsForPeerSync`
    `Map<String,CacheConfig>` | `userCacheConfigs`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SolrConfig()` Creates a default instance from the solrconfig.xml.
    `SolrConfig(Path instanceDir, String name, InputSource is)` Creates a configuration instance from an instance directory, configuration name and stream.
    `SolrConfig(SolrResourceLoader loader, String name, InputSource is)` Creates a configuration instance from a resource loader, a configuration name and a stream.
    `SolrConfig(String name)` Creates a configuration instance from a configuration name.
    `SolrConfig(String name, InputSource is)` Creates a configuration instance from a configuration name and stream.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `get(String path)`
    `String` | `get(String path, String def)`
    `boolean` | `getBool(String path, boolean def)`
    `static ConfigOverlay` | `getConfigOverlay(SolrResourceLoader loader)`
    `String` | `getDataDir()`
    `int` | `getFormUploadLimitKB()`
    `SolrConfig.HttpCachingConfig` | `getHttpCachingConfig()`
    `Map<String,InitParams>` | `getInitParams()`
    `int` | `getInt(String path)`
    `int` | `getInt(String path, int def)`
    `int` | `getMultipartUploadLimitKB()`
    `ConfigOverlay` | `getOverlay()`
    `PluginInfo` | `getPluginInfo(String type)`
    `List<PluginInfo>` | `getPluginInfos(String type)` SolrConfig keeps a repository of plugins by the type.
    `RequestParams` | `getRequestParams()`
    `SolrRequestParsers` | `getRequestParsers()`
    `protected Properties` | `getSubstituteProperties()`
    `SolrConfig.UpdateHandlerInfo` | `getUpdateHandlerInfo()`
    `boolean` | `isAddHttpRequestToContext()`
    `boolean` | `isEnableRemoteStreams()`
    `boolean` | `isHandleSelect()`
    `protected SolrConfig.UpdateHandlerInfo` | `loadUpdatehandlerInfo()`
    `static SolrConfig` | `readFromResourceLoader(SolrResourceLoader loader, String name)`
    `List<PluginInfo>` | `readPluginInfos(String tag, boolean requireName, boolean requireClass)`
    `RequestParams` | `refreshRequestParams()`
    `Map<String,Object>` | `toMap(Map<String,Object> result)`

    - ### Methods inherited from class org.apache.solr.core.Config

      `assertWarnOrFail, complainAboutUnknownAttributes, evaluate, getBool, getDocument, getDouble, getDouble, getFloat, getFloat, getLuceneVersion, getLuceneVersion, getName, getNode, getNode, getNodeList, getOriginalConfig, getResourceLoader, getResourceName, getUnknownAttributes, getUnsubstitutedNode, getVal, getXPath, getZnodeVersion, parseLuceneVersionString, substituteProperties`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_CONF_FILE

          public static final String DEFAULT_CONF_FILE

      See Also:
        Constant Field Values

    - #### plugins

          public static final List<SolrConfig.SolrPluginInfo> plugins

    - #### classVsSolrPluginInfo

          public static final Map<String,SolrConfig.SolrPluginInfo> classVsSolrPluginInfo

    - #### booleanQueryMaxClauseCount

          public final int booleanQueryMaxClauseCount

    - #### filterCacheConfig

          public final CacheConfig filterCacheConfig

    - #### queryResultCacheConfig

          public final CacheConfig queryResultCacheConfig

    - #### documentCacheConfig

          public final CacheConfig documentCacheConfig

    - #### fieldValueCacheConfig

          public final CacheConfig fieldValueCacheConfig

    - #### userCacheConfigs

          public final Map<String,CacheConfig> userCacheConfigs

    - #### useFilterForSortedQuery

          public final boolean useFilterForSortedQuery

    - #### queryResultWindowSize

          public final int queryResultWindowSize

    - #### queryResultMaxDocsCached

          public final int queryResultMaxDocsCached

    - #### enableLazyFieldLoading

          public final boolean enableLazyFieldLoading

    - #### useRangeVersionsForPeerSync

          public final boolean useRangeVersionsForPeerSync

    - #### hashSetInverseLoadFactor

          public final float hashSetInverseLoadFactor

    - #### hashDocSetMaxSize

          public final int hashDocSetMaxSize

    - #### indexConfig

          public final SolrIndexConfig indexConfig

    - #### updateHandlerInfo

          protected SolrConfig.UpdateHandlerInfo updateHandlerInfo

    - #### maxWarmingSearchers

          public final int maxWarmingSearchers

    - #### useColdSearcher

          public final boolean useColdSearcher

    - #### luceneMatchVersion

          public final Version luceneMatchVersion

    - #### dataDir

          protected String dataDir

    - #### slowQueryThresholdMillis

          public final int slowQueryThresholdMillis

    - #### jmxConfig

          public final SolrConfig.JmxConfiguration jmxConfig

  - ### Constructor Detail

    - #### SolrConfig

          public SolrConfig()
                     throws ParserConfigurationException,
                            IOException,
                            SAXException

      Creates a default instance from the solrconfig.xml.
      Throws:
        `ParserConfigurationException`
        `IOException`
        `SAXException`

    - #### SolrConfig

          public SolrConfig(String name)
                     throws ParserConfigurationException,
                            IOException,
                            SAXException

      Creates a configuration instance from a configuration name. A default resource loader will be created (@see SolrResourceLoader)
      Parameters:
        `name` - the configuration name used by the loader
      Throws:
        `ParserConfigurationException`
        `IOException`
        `SAXException`

    - #### SolrConfig

          public SolrConfig(String name,
                            InputSource is)
                     throws ParserConfigurationException,
                            IOException,
                            SAXException

      Creates a configuration instance from a configuration name and stream. A default resource loader will be created (@see SolrResourceLoader). If the stream is null, the resource loader will open the configuration stream. If the stream is not null, no attempt to load the resource will occur (the name is not used).
      Parameters:
        `name` - the configuration name
        `is` - the configuration stream
      Throws:
        `ParserConfigurationException`
        `IOException`
        `SAXException`

    - #### SolrConfig

          public SolrConfig(Path instanceDir,
                            String name,
                            InputSource is)
                     throws ParserConfigurationException,
                            IOException,
                            SAXException

      Creates a configuration instance from an instance directory, configuration name and stream.
      Parameters:
        `instanceDir` - the directory used to create the resource loader
        `name` - the configuration name used by the loader if the stream is null
        `is` - the configuration stream
      Throws:
        `ParserConfigurationException`
        `IOException`
        `SAXException`

    - #### SolrConfig

          public SolrConfig(SolrResourceLoader loader,
                            String name,
                            InputSource is)
                     throws ParserConfigurationException,
                            IOException,
                            SAXException

      Creates a configuration instance from a resource loader, a configuration name and a stream. If the stream is null, the resource loader will open the configuration stream. If the stream is not null, no attempt to load the resource will occur (the name is not used).
      Parameters:
        `loader` - the resource loader
        `name` - the configuration name
        `is` - the configuration stream
      Throws:
        `ParserConfigurationException`
        `IOException`
        `SAXException`

  - ### Method Detail

    - #### readFromResourceLoader

          public static SolrConfig readFromResourceLoader(SolrResourceLoader loader,
                                                          String name)

    - #### getConfigOverlay

          public static ConfigOverlay getConfigOverlay(SolrResourceLoader loader)

    - #### getInitParams

          public Map<String,InitParams> getInitParams()

    - #### loadUpdatehandlerInfo

          protected SolrConfig.UpdateHandlerInfo loadUpdatehandlerInfo()

    - #### readPluginInfos

          public List<PluginInfo> readPluginInfos(String tag,
                                                  boolean requireName,
                                                  boolean requireClass)

    - #### getRequestParsers

          public SolrRequestParsers getRequestParsers()

    - #### getHttpCachingConfig

          public SolrConfig.HttpCachingConfig getHttpCachingConfig()

    - #### getUpdateHandlerInfo

          public SolrConfig.UpdateHandlerInfo getUpdateHandlerInfo()

    - #### getDataDir

          public String getDataDir()

    - #### getPluginInfos

          public List<PluginInfo> getPluginInfos(String type)

      SolrConfig keeps a repository of plugins by the type. The known interfaces are the types.
      Parameters:
        `type` - The key is FQN of the plugin class there are a few known types : SolrFormatter, SolrFragmenter SolrRequestHandler,QParserPlugin, QueryResponseWriter,ValueSourceParser, SearchComponent, QueryConverter, SolrEventListener, DirectoryFactory, IndexDeletionPolicy, IndexReaderFactory, `TransformerFactory`

    - #### getPluginInfo

          public PluginInfo getPluginInfo(String type)

    - #### getMultipartUploadLimitKB

          public int getMultipartUploadLimitKB()

    - #### getFormUploadLimitKB

          public int getFormUploadLimitKB()

    - #### isHandleSelect

          public boolean isHandleSelect()

    - #### isAddHttpRequestToContext

          public boolean isAddHttpRequestToContext()

    - #### isEnableRemoteStreams

          public boolean isEnableRemoteStreams()

    - #### getInt

          public int getInt(String path)

      Overrides:
        `getInt` in class `Config`

    - #### getInt

          public int getInt(String path,
                            int def)

      Overrides:
        `getInt` in class `Config`

    - #### getBool

          public boolean getBool(String path,
                                 boolean def)

      Overrides:
        `getBool` in class `Config`

    - #### get

          public String get(String path)

      Overrides:
        `get` in class `Config`

    - #### get

          public String get(String path,
                            String def)

      Overrides:
        `get` in class `Config`

    - #### toMap

          public Map<String,Object> toMap(Map<String,Object> result)

      Specified by:
        `toMap` in interface `MapSerializable`

    - #### getSubstituteProperties

          protected Properties getSubstituteProperties()

      Overrides:
        `getSubstituteProperties` in class `Config`

    - #### getOverlay

          public ConfigOverlay getOverlay()

    - #### getRequestParams

          public RequestParams getRequestParams()

    - #### refreshRequestParams

          public RequestParams refreshRequestParams()

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.